unit u__04_wm_touch_move_item;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 =
      class(TForm)
        Memo1: TMemo;
        clear_: TButton;
        Panel1: TPanel;
        procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
      private
        procedure CreateWnd; override;
        procedure DestroyWnd; override;
      public
        procedure handle_wm_touch(var Message: TMessage); message WM_TOUCH;
      end;

var
  Form1: TForm1;

implementation
  uses Vcl.Touch.Gestures;

  {$R *.dfm}

    const k_radius= 30;
    var g_center_x, g_center_y: Integer;

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end;

    procedure TForm1.CreateWnd;
      begin
        inherited;
        RegisterTouchWindow(Handle, 0);
      end; // CreateWnd

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        g_center_x:= 50;
        g_center_y:= 50;
      end;

    procedure TForm1.FormPaint(Sender: TObject);
      begin
        Canvas.Ellipse(g_center_x- k_radius, g_center_y- k_radius,
            g_center_x+ k_radius, g_center_y+ k_radius);
      end;

    procedure TForm1.handle_wm_touch(var Message: TMessage);

      function f_touchpoint_to_logical_point(const p_touch_point: TTouchInput): TPoint;
          // -- converts the physical (hi def) coordinates into physical screen pixels
        begin
          Result := Point(p_touch_point.X div 100, p_touch_point.Y div 100);
          PhysicalToLogicalPoint(Handle, Result);
        end; // f_touchpoint_to_logical_point

      var l_touchinput_array: array of TTouchInput;
          l_touchinput: TTouchInput;
          l_handled: Boolean;
          l_logical_point: TPoint;
          l_screen_point: tPoint;

      begin // handle_wm_touch
        l_handled := False;
        display('wm_touch, count '+ IntToStr(Message.WParam));

        SetLength(l_touchinput_array, Message.WParam);

        GetTouchInputInfo(Message.LParam, Message.WParam, @l_touchinput_array[0],
            SizeOf(TTouchInput));

        try
          for l_touchinput in l_touchinput_array do
          begin
            l_logical_point:= f_touchpoint_to_logical_point(l_touchinput);
            l_screen_point:= ScreenToClient(l_logical_point);
            display(Format ('    scr X=%3d Y=%3d   screen_X=%3d Y=%3d',
                [l_logical_point.X, l_logical_point.Y,
                 l_screen_point.X, l_screen_point.Y]));

            if (l_touchinput.dwFlags and TouchEventF_Move)<> 0
              then begin
                  g_center_x:= l_screen_point.X;
                  g_center_y:= l_screen_point.Y;
                  OnPaint(Nil);
                end;
          end; // for l_touchinput

          l_handled := True;
        finally
          if l_handled then
            CloseTouchInputHandle(Message.LParam)
          else
            inherited;
        end;
      end; // handle_wm_touch

    procedure TForm1.DestroyWnd;
      begin
        inherited;
        UnregisterTouchWindow(Handle);
      end; // DestroyWnd

end.
